// TsStream.cpp: TSXg[bp[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsStream.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// CTsPacketNX̍\z/
//////////////////////////////////////////////////////////////////////

CTsPacket::CTsPacket()
	: CMediaData(188)
{
	// ̃pPbg𐶐
	::ZeroMemory(&m_Header, sizeof(m_Header));
	::ZeroMemory(&m_AdaptationField, sizeof(m_AdaptationField));
}

CTsPacket::CTsPacket(const BYTE *pHexData)
	: CMediaData(pHexData, 188)
{
	// oCif[^pPbg𐶐
	ParseHeader();
}

CTsPacket::CTsPacket(const CTsPacket &Operand)
{
	*this = Operand;
}
	
CTsPacket & CTsPacket::operator = (const CTsPacket &Operand)
{
	// CX^X̃Rs[
	CMediaData::operator = (Operand);

	m_Header = Operand.m_Header;
	m_AdaptationField = Operand.m_AdaptationField;

	m_Payload.m_byDataLength = Operand.m_Payload.m_byDataLength;
	m_Payload.m_pHexData = &m_pData[Operand.m_Payload.m_pHexData - Operand.m_pData];

	return *this;
}

void CTsPacket::ParseHeader(void)
{
	// TSpPbgwb_
	m_Header.bySyncByte					= m_pData[0];							// +0
	m_Header.bTransportErrorIndicator	= (m_pData[1] & 0x80)? true : false;	// +1 bit7
	m_Header.bPayloadUnitStartIndicator	= (m_pData[1] & 0x40)? true : false;	// +1 bit6
	m_Header.TransportPriority			= (m_pData[1] & 0x20)? true : false;	// +1 bit5
	m_Header.wPID = ((WORD)(m_pData[1] & 0x1F) << 8) | (WORD)m_pData[2];		// +1 bit4-0, +2
	m_Header.byTransportScramblingCtrl	= (m_pData[3] & 0xC0) >> 6;				// +3 bit7-6
	m_Header.byAdaptationFieldCtrl		= (m_pData[3] & 0x30) >> 4;				// +3 bit5-4
	m_Header.byContinuityCounter		= m_pData[3] & 0x0F;					// +3 bit3-0
	
	// A_ve[VtB[h
	::ZeroMemory(&m_AdaptationField, sizeof(m_AdaptationField));
	m_Payload.m_pHexData = NULL;
	m_Payload.m_byDataLength = 0;
	
	if(m_Header.byAdaptationFieldCtrl & 0x02){
		// A_ve[VtB[h
		if(m_AdaptationField.byAdaptationFieldLength = m_pData[4]){								// +4
			// tB[hȍ~
			m_AdaptationField.bDiscontinuityIndicator	= (m_pData[5] & 0x80)? true : false;	// +5 bit7
			m_AdaptationField.bRamdomAccessIndicator	= (m_pData[5] & 0x40)? true : false;	// +5 bit6
			m_AdaptationField.bEsPriorityIndicator		= (m_pData[5] & 0x20)? true : false;	// +5 bit5
			m_AdaptationField.byFiveFlags				= m_pData[5] & 0x1F;					// +5 bit4-0
			m_AdaptationField.pOptionField				= (m_pData[4] > 1)? &m_pData[6] : NULL;
			}
		
		if(m_Header.byAdaptationFieldCtrl & 0x01){
			// yC[h
			m_Payload.m_pHexData = &m_pData[m_pData[4] + 5];
			}
		}
	else if(m_Header.byAdaptationFieldCtrl & 0x01){
		// A_ve[VtB[hȂAyC[h
		m_Payload.m_pHexData = &m_pData[4];
		}

	// yC[hJnʒu␳AyC[hݒ
	if(m_Payload.m_pHexData){
		if(m_Header.bPayloadUnitStartIndicator)m_Payload.m_pHexData++;
		m_Payload.m_byDataLength = (BYTE)(&m_pData[188] - m_Payload.m_pHexData);
		}
}

const bool CTsPacket::CheckPacket(BYTE *pContinuityCounter)
{
	bool bValid = true;

	// pPbg̃tH[}bgK`FbN
	if(m_Header.bySyncByte != 0x47)bValid = false;								// oCgs
	else if(m_Header.bTransportErrorIndicator)bValid = false;					// rbg肠
	else if(m_Header.wPID >= 0x0002 && m_Header.wPID <= 0x000F)bValid = false;	// `PID͈
	else if(m_Header.byTransportScramblingCtrl == 0x01)bValid = false;			// `XNul
	else if(m_Header.byAdaptationFieldCtrl == 0x00)bValid = false;				// `A_ve[VtB[hl
	else if(m_Header.byAdaptationFieldCtrl == 0x02 && m_AdaptationField.byAdaptationFieldLength > 183)bValid = false;	// A_ve[VtB[hُ
	else if(m_Header.byAdaptationFieldCtrl == 0x03 && m_AdaptationField.byAdaptationFieldLength > 182)bValid = false;	// A_ve[VtB[hُ

	if(!pContinuityCounter)return bValid;

	// A`FbN
	const BYTE byNewCounter = (m_Payload.m_pHexData)? m_Header.byContinuityCounter : 0x10;

	if(*pContinuityCounter < 0x10 && byNewCounter < 0x10){
		if(((*pContinuityCounter + 1) & 0x0F) != byNewCounter){
			bValid = false;
			}
		}

	// JE^XV
	*pContinuityCounter = byNewCounter;

	return bValid;
}

const WORD CTsPacket::GetPID(void) const
{
	// PIDԂ
	return m_Header.wPID;
}

const bool CTsPacket::HaveAdaptationField(void) const
{
	// A_ve[VtB[h̗LԂ
	return (m_Header.byAdaptationFieldCtrl & 0x02)? true : false;
}

const bool CTsPacket::HavePayload(void) const
{
	// yC[h̗LԂ
	return (m_Payload.m_pHexData && m_Payload.m_byDataLength)? true : false;
}

const BYTE CTsPacket::GetUnitStartPostion(void) const
{
	// jbgX^[gʒuԂ
	return (HavePayload() && m_Header.bPayloadUnitStartIndicator)?  *(m_Payload.m_pHexData - 1) : 0;
}


//////////////////////////////////////////////////////////////////////
// CTsPayloadNX̍\z/
//////////////////////////////////////////////////////////////////////

CTsPayload::CTsPayload()
	: m_pHexData(NULL)
	, m_byDataLength(0)
{

}

CTsPayload::CTsPayload(const CTsPayload &Operand)
{
	*this = Operand;
}
	
CTsPayload & CTsPayload::operator = (const CTsPayload &Operand)
{
	m_pHexData = Operand.m_pHexData;
	m_byDataLength = Operand.m_byDataLength;

	return *this;
}


//////////////////////////////////////////////////////////////////////
// CPsiSectionNX̍\z/
//////////////////////////////////////////////////////////////////////

CPsiSection::CPsiSection()
	: CMediaData()
{
	Reset();
}

CPsiSection::CPsiSection(const CPsiSection &Operand)
{
	Reset();

	*this = Operand;
}

CPsiSection & CPsiSection::operator = (const CPsiSection &Operand)
{
	// CX^X̃Rs[
	CMediaData::operator = (Operand);
	m_Header = Operand.m_Header;

	return *this;
}

const bool CPsiSection::operator == (const CPsiSection &Operand)
{
	// ZNV̓er
	if(GetSize() != Operand.GetSize()){
		// TCYقȂ
		return false;
		}
	else{
		// oCir
		for(DWORD dwPos = 0 ; dwPos < GetSize() ; dwPos++){
			if(GetAt(dwPos) != Operand.GetAt(dwPos))return false;
			}
		
		// v
		return true;
		}
}

const bool CPsiSection::ParseHeader(const BYTE *pHexData, const bool bIsExtended)
{
	Reset();

	// W`wb_
	m_Header.byTableID					= pHexData[0];									// +0
	m_Header.bSectionSyntaxIndicator	= (pHexData[1] & 0x80)? true : false;			// +1 bit7
	m_Header.bPrivateIndicator			= (pHexData[1] & 0x40)? true : false;			// +1 bit6
	m_Header.wSectionLength = ((WORD)(pHexData[1] & 0x0F) << 8) | (WORD)pHexData[2];	// +1 bit5-0, +2

	if(m_Header.bSectionSyntaxIndicator && bIsExtended){
		// g`̃wb_
		m_Header.wTableIdExtension		= (WORD)pHexData[3] << 8 | (WORD)pHexData[4];	// +3, +4
		m_Header.byVersionNo			= (pHexData[5] & 0x3E) >> 1;					// +5 bit5-1
		m_Header.bCurrentNextIndicator	= (pHexData[5] & 0x01)? true : false;			// +5 bit0
		m_Header.bySectionNumber		= pHexData[6];									// +6
		m_Header.byLastSectionNumber	= pHexData[7];									// +7
		}

	// wb_̃tH[}bgK`FbN
	if((pHexData[1] & 0x30) != 0x30)return false;										// Œrbgُ
	else if(m_Header.wSectionLength > 4093)return false;								// ZNVُ
	else if(m_Header.bSectionSyntaxIndicator){
		// g`̃G[`FbN
		if(!bIsExtended)return false;													// ړĨwb_ł͂Ȃ
		else if((pHexData[5] & 0xC0) != 0xC0)return false;								// Œrbgُ
		else if(m_Header.bySectionNumber > m_Header.byLastSectionNumber)return false;	// ZNVԍُ
		else if(m_Header.wSectionLength < 9)return false;								// ZNVُ
		}
	else{
		// W`̃G[`FbN	
		if(bIsExtended)return false;													// ړĨwb_ł͂Ȃ
		else if(m_Header.wSectionLength < 4)return false;								// ZNVُ
		}

	return true;
}

void CPsiSection::Reset(void)
{
	// f[^NA
	ClearSize();	
	::ZeroMemory(&m_Header, sizeof(m_Header));
}

const BYTE CPsiSection::GetTableID(void) const
{
	// e[uIDԂ
	return m_Header.byTableID;
}

const bool CPsiSection::IsExtendedSection(void) const
{
	// ZNVV^bNXCWP[^Ԃ
	return m_Header.bSectionSyntaxIndicator;
}

const bool CPsiSection::IsPrivate(void) const
{
	// vCx[gCWP[^Ԃ
	return m_Header.bPrivateIndicator;
}

const WORD CPsiSection::GetTableIdExtension(void) const
{
	// e[uIDgԂ
	return m_Header.wTableIdExtension;
}

const BYTE CPsiSection::GetVersionNo(void) const
{
	// o[WԍԂ
	return m_Header.byVersionNo;
}

const bool CPsiSection::IsCurrentNext(void) const
{
	// JglNXgCWP[^Ԃ
	return m_Header.bCurrentNextIndicator;
}

const BYTE CPsiSection::GetSectionNumber(void) const
{
	// ZNVԍԂ
	return m_Header.bySectionNumber;
}

const BYTE CPsiSection::GetLastSectionNumber(void) const
{
	// XgZNVԍԂ
	return m_Header.byLastSectionNumber;
}


/////////////////////////////////////////////////////////////////////////////
// PSIZNVoNX
/////////////////////////////////////////////////////////////////////////////

CPsiSectionParser::CPsiSectionParser()
	: m_pfnSectionRecvFunc(NULL)
	, m_pCallbackParam(NULL)
	, m_bTargetExt(true)
	, m_bIsStoring(false)
	, m_dwCrcErrorCount(0)
{

}

CPsiSectionParser::CPsiSectionParser(const CPsiSectionParser &Operand)
{
	*this = Operand;
}

CPsiSectionParser & CPsiSectionParser::operator = (const CPsiSectionParser &Operand)
{
	m_pfnSectionRecvFunc = Operand.m_pfnSectionRecvFunc;
	m_pCallbackParam = Operand.m_pCallbackParam;
	m_bTargetExt = Operand.m_bTargetExt;
	m_PsiSection = Operand.m_PsiSection;
	m_bIsStoring = Operand.m_bIsStoring;
	m_dwStoreCrc = Operand.m_dwStoreCrc;
	m_wStoreSize = Operand.m_wStoreSize;
	m_dwCrcErrorCount = Operand.m_dwCrcErrorCount;

	return *this;
}

void CPsiSectionParser::SetRecvCallback(const bool bTargetExt, const SECTIONRECVFUNC pCallback, const PVOID pParam)
{
	// ΏۃZNV̎(g or W)AZNV󂯎R[obNAp[^ݒ肷
	m_bTargetExt = bTargetExt;
	m_pfnSectionRecvFunc = pCallback;
	m_pCallbackParam = pParam;
}

void CPsiSectionParser::StorePacket(const CTsPacket *pPacket)
{
	const BYTE *pData = pPacket->m_Payload.m_pHexData;
	const BYTE bySize = pPacket->m_Payload.m_byDataLength;
	BYTE byPos = 0;

	if(!bySize || !pData)return;

	// ZNV̑XgA
	byPos += StoreUnit(&pData[byPos], bySize - byPos);

	// VȃZNṼXgAJn
	if(pPacket->m_Header.bPayloadUnitStartIndicator){
		byPos = pPacket->GetUnitStartPostion();
		byPos += StartUnit(&pData[byPos], bySize - byPos);
		byPos += StoreUnit(&pData[byPos], bySize - byPos);
		}

	return;
}

void CPsiSectionParser::Reset(void)
{
	// Ԃ
	m_bIsStoring = false;
	m_wStoreSize = 0;
	m_dwCrcErrorCount = 0;
}

const DWORD CPsiSectionParser::GetCrcErrorCount(void) const
{
	// CRCG[񐔂Ԃ
	return m_dwCrcErrorCount;
}

const BYTE CPsiSectionParser::StartUnit(const BYTE *pPayload, const BYTE byRemain)
{
	// wb_͂ăZNṼXgAJn
	if(m_bIsStoring)return 0;

	const BYTE byHeaderSize = (m_bTargetExt)? 8 : 3;
	
	if(byRemain >= byHeaderSize){
		if(m_PsiSection.ParseHeader(pPayload, m_bTargetExt)){
			// wb_tH[}bgOKAwb_݂̂CRCvZ
			m_wStoreSize = m_PsiSection.m_Header.wSectionLength - (byHeaderSize - 3);
			m_dwStoreCrc = CalcCrc(pPayload, byHeaderSize);

			m_bIsStoring = true;

			return byHeaderSize;
			}	
		}

	// G[
	return byRemain;
}

const BYTE CPsiSectionParser::StoreUnit(const BYTE *pPayload, const BYTE byRemain)
{
	// ZNṼXgA
	if(!m_bIsStoring)return 0;
	
	const WORD wStoreRemain = m_wStoreSize - (WORD)m_PsiSection.GetSize();

	if(wStoreRemain <= (WORD)byRemain){
		// XgA
		m_PsiSection.AddData(pPayload, wStoreRemain);
				
		if(!CalcCrc(pPayload, wStoreRemain, m_dwStoreCrc)){
			// CRC
			m_PsiSection.TrimTail(4);
					
			// R[obNɃZNVn
			if(m_pfnSectionRecvFunc)m_pfnSectionRecvFunc(&m_PsiSection, m_pCallbackParam);
			//TRACE(TEXT("[%02X]: %u/%u\n"), m_PsiSection.GetTableID(), m_PsiSection.GetSize(), m_wStoreSize);
			}
		else{
			// CRCُ
			if(m_dwCrcErrorCount < 0xFFFFFFFF)m_dwCrcErrorCount++;
			//TRACE(TEXT("[%02X]CRCُ: %u/%u\n"), m_PsiSection.GetTableID(), m_PsiSection.GetSize(), m_wStoreSize);
			}
		
		m_bIsStoring = false;

		return (BYTE)wStoreRemain;
		}
	else{
		// XgAÃyC[h҂
		m_PsiSection.AddData(pPayload, (WORD)byRemain);
		m_dwStoreCrc = CalcCrc(pPayload, (WORD)byRemain, m_dwStoreCrc);

		return byRemain;
		}
}

const DWORD CPsiSectionParser::CalcCrc(const BYTE *pData, const WORD wDataSize, DWORD dwCurCrc)
{
	// CRC32vZ(uMpeg2-TS̃Xg[f[^𒊏oeXgvR[h𗬗pAvZ𕪊ł悤Ɋg)
	static const DWORD CrcTable[256] = {
		0x00000000, 0x04C11DB7, 0x09823B6E, 0x0D4326D9,	0x130476DC, 0x17C56B6B, 0x1A864DB2, 0x1E475005,	0x2608EDB8, 0x22C9F00F, 0x2F8AD6D6, 0x2B4BCB61,	0x350C9B64, 0x31CD86D3, 0x3C8EA00A, 0x384FBDBD,
		0x4C11DB70, 0x48D0C6C7, 0x4593E01E, 0x4152FDA9,	0x5F15ADAC, 0x5BD4B01B, 0x569796C2, 0x52568B75,	0x6A1936C8, 0x6ED82B7F, 0x639B0DA6, 0x675A1011,	0x791D4014, 0x7DDC5DA3, 0x709F7B7A, 0x745E66CD,
		0x9823B6E0, 0x9CE2AB57, 0x91A18D8E, 0x95609039,	0x8B27C03C, 0x8FE6DD8B, 0x82A5FB52, 0x8664E6E5,	0xBE2B5B58, 0xBAEA46EF, 0xB7A96036, 0xB3687D81,	0xAD2F2D84, 0xA9EE3033, 0xA4AD16EA, 0xA06C0B5D,
		0xD4326D90, 0xD0F37027, 0xDDB056FE, 0xD9714B49,	0xC7361B4C, 0xC3F706FB, 0xCEB42022, 0xCA753D95,	0xF23A8028, 0xF6FB9D9F, 0xFBB8BB46, 0xFF79A6F1,	0xE13EF6F4, 0xE5FFEB43, 0xE8BCCD9A, 0xEC7DD02D,
		0x34867077, 0x30476DC0, 0x3D044B19, 0x39C556AE,	0x278206AB, 0x23431B1C, 0x2E003DC5, 0x2AC12072,	0x128E9DCF, 0x164F8078, 0x1B0CA6A1, 0x1FCDBB16,	0x018AEB13, 0x054BF6A4, 0x0808D07D, 0x0CC9CDCA,
		0x7897AB07, 0x7C56B6B0, 0x71159069, 0x75D48DDE,	0x6B93DDDB, 0x6F52C06C, 0x6211E6B5, 0x66D0FB02,	0x5E9F46BF, 0x5A5E5B08, 0x571D7DD1, 0x53DC6066,	0x4D9B3063, 0x495A2DD4, 0x44190B0D, 0x40D816BA,
		0xACA5C697, 0xA864DB20, 0xA527FDF9, 0xA1E6E04E,	0xBFA1B04B, 0xBB60ADFC, 0xB6238B25, 0xB2E29692,	0x8AAD2B2F, 0x8E6C3698, 0x832F1041, 0x87EE0DF6,	0x99A95DF3, 0x9D684044, 0x902B669D, 0x94EA7B2A,
		0xE0B41DE7, 0xE4750050, 0xE9362689, 0xEDF73B3E,	0xF3B06B3B, 0xF771768C, 0xFA325055, 0xFEF34DE2,	0xC6BCF05F, 0xC27DEDE8, 0xCF3ECB31, 0xCBFFD686,	0xD5B88683, 0xD1799B34, 0xDC3ABDED, 0xD8FBA05A,
		0x690CE0EE, 0x6DCDFD59, 0x608EDB80, 0x644FC637,	0x7A089632, 0x7EC98B85, 0x738AAD5C, 0x774BB0EB,	0x4F040D56, 0x4BC510E1, 0x46863638, 0x42472B8F,	0x5C007B8A, 0x58C1663D, 0x558240E4, 0x51435D53,
		0x251D3B9E, 0x21DC2629, 0x2C9F00F0, 0x285E1D47,	0x36194D42, 0x32D850F5, 0x3F9B762C, 0x3B5A6B9B,	0x0315D626, 0x07D4CB91, 0x0A97ED48, 0x0E56F0FF,	0x1011A0FA, 0x14D0BD4D, 0x19939B94, 0x1D528623,
		0xF12F560E, 0xF5EE4BB9, 0xF8AD6D60, 0xFC6C70D7,	0xE22B20D2, 0xE6EA3D65, 0xEBA91BBC, 0xEF68060B,	0xD727BBB6, 0xD3E6A601, 0xDEA580D8, 0xDA649D6F,	0xC423CD6A, 0xC0E2D0DD, 0xCDA1F604, 0xC960EBB3,
		0xBD3E8D7E, 0xB9FF90C9, 0xB4BCB610, 0xB07DABA7,	0xAE3AFBA2, 0xAAFBE615, 0xA7B8C0CC, 0xA379DD7B,	0x9B3660C6, 0x9FF77D71, 0x92B45BA8, 0x9675461F,	0x8832161A, 0x8CF30BAD, 0x81B02D74, 0x857130C3,
		0x5D8A9099, 0x594B8D2E, 0x5408ABF7, 0x50C9B640,	0x4E8EE645, 0x4A4FFBF2, 0x470CDD2B, 0x43CDC09C,	0x7B827D21, 0x7F436096, 0x7200464F, 0x76C15BF8,	0x68860BFD, 0x6C47164A, 0x61043093, 0x65C52D24,
		0x119B4BE9, 0x155A565E, 0x18197087, 0x1CD86D30,	0x029F3D35, 0x065E2082, 0x0B1D065B, 0x0FDC1BEC,	0x3793A651, 0x3352BBE6, 0x3E119D3F, 0x3AD08088,	0x2497D08D, 0x2056CD3A, 0x2D15EBE3, 0x29D4F654,
		0xC5A92679, 0xC1683BCE, 0xCC2B1D17, 0xC8EA00A0,	0xD6AD50A5, 0xD26C4D12, 0xDF2F6BCB, 0xDBEE767C,	0xE3A1CBC1, 0xE760D676, 0xEA23F0AF, 0xEEE2ED18,	0xF0A5BD1D, 0xF464A0AA, 0xF9278673, 0xFDE69BC4,
		0x89B8FD09, 0x8D79E0BE, 0x803AC667, 0x84FBDBD0,	0x9ABC8BD5, 0x9E7D9662, 0x933EB0BB, 0x97FFAD0C,	0xAFB010B1, 0xAB710D06, 0xA6322BDF, 0xA2F33668,	0xBCB4666D, 0xB8757BDA, 0xB5365D03, 0xB1F740B4
		};		

	for(WORD wPos = 0 ; wPos < wDataSize ; wPos++){
		dwCurCrc = (dwCurCrc << 8) ^ CrcTable[ (dwCurCrc >> 24) ^ pData[wPos] ];
		}

	return dwCurCrc;
}


